unit CubEqu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Mask, ImgList, Math;

type
  TfrmMain = class(TForm)
    EditA: TEdit;
    EditB: TEdit;
    EditC: TEdit;
    EditD: TEdit;
    BtnSolve: TButton;
    lblSolution: TLabel;
    btnClear: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lblSolution2: TLabel;
    lblSolution3: TLabel;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuSolve: TMenuItem;
    mnuExit: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    btnRandom: TButton;
    btnExit: TButton;
    PopupMenu: TPopupMenu;
    popmnusolve: TMenuItem;
    popmnuClear: TMenuItem;
    popmnuExit: TMenuItem;
    lblTest1: TLabel;
    lblTest2: TLabel;
    lblTest3: TLabel;
    btnTest: TButton;
    mnuRandom: TMenuItem;
    mnuClear: TMenuItem;
    procedure BtnSolveClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure mnuSolveClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure btnRandomClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure popmnusolveClick(Sender: TObject);
    procedure popmnuClearClick(Sender: TObject);
    procedure popmnuExitClick(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
    procedure mnuRandomClick(Sender: TObject);
    procedure mnuClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  y,y1,y2,y3,a,b,c,d:double;
implementation

{$R *.DFM}

procedure TfrmMain.BtnSolveClick(Sender: TObject);
  var h,hh:string;
      p,q,dd,r,fi,aa,bb,cc,ddd:double;
      code:integer;
  function f(x:real):real;
    //   1/3
    begin
      if x>0
        then
          f:=exp(1/3*ln(x))
        else
          if x<0
            then
              f:=-exp(1/3*ln(abs(x)))
            else
              f:=0
    end;
begin
  lblSolution.Caption:=':';
  lblSolution2.Caption:='';
  lblSolution3.Caption:='';
  lblTest1.Caption:='f(x1)=';
  lblTest2.Caption:='f(x2)=';
  lblTest3.Caption:='f(x3)=';
  h:=EditA.Text;
  val(h,a,code);
  h:=EditB.Text;
  val(h,b,code);
  h:=EditC.Text;
  val(h,c,code);
  h:=EditD.Text;
  val(h,d,code);
  if a<>0
    then
      begin
        //  
        p:=-b*b/3/a/a+c/a;
        q:=2*b*b*b/27/a/a/a-b*c/3/a/a+d/a;
        dd:=q*q/4+p*p*p/27;
        if dd>0
          then
            begin
               // 1  
               dd:=sqrt(dd);
               y:=f(-q/2+dd)+f(-q/2-dd)-b/3/a;
               str(y:5:7,h);
               lblSolution.Caption:=lblSolution.Caption+'x1='+h
            end
          else
            if dd=0
              then
                begin
                  // 2 
                  y:=f(-q/2)*2-b/3/a;
                  str(y:5:7,h);
                  lblSolution.Caption:=lblSolution.Caption+'x1='+h
                end
              else
                begin
                  // 3 
                  r:=sqrt(q*q/4-dd);
                  fi:=abs(arccos(-q/2/r));
                  y:=2*f(r)*cos(fi/3)-b/3/a;
                  str(y:5:7,h);
                  lblSolution.Caption:=lblSolution.Caption+'x1='+h
                end;
        // 2  
        aa:=a;
        bb:=b+a*y;
        cc:=c+y*bb;
        ddd:=bb*bb-4*aa*cc;
        if ddd>0
          then
            begin
              //2 
              y1:=(-bb-sqrt(ddd))/2/aa;
              y2:=(-bb+sqrt(ddd))/2/aa;
              str(y1:5:7,h);
              lblSolution2.Caption:=lblSolution2.Caption+'x2='+h;
              str(y2:5:7,h);
              lblSolution3.Caption:=lblSolution3.Caption+'x3='+h
            end
          else
            if ddd=0
              then
                begin
                  //2  
                  y1:=-bb/2/aa;
                  str(y1:5:7,h);
                  lblSolution2.Caption:=lblSolution2.Caption+'x2='+h;
                  lblSolution3.Caption:=lblSolution3.Caption+'x3='+h
                end
              else
                begin
                  //  
                  y2:=-bb/2/aa; // 
                  y3:=sqrt(-ddd)/2/a; // 
                  str(y2:5:7,h);
                  str(y3:5:7,hh);
                  if a>0
                    then
                      begin
                        if abs(y2)>1e-7
                          then
                            begin
                              lblSolution2.Caption:=lblSolution2.Caption+'x2='+h+'+i*'+hh;
                              lblSolution3.Caption:=lblSolution3.Caption+'x3='+h+'-i*'+hh;
                            end
                          else
                            begin
                              lblSolution2.Caption:=lblSolution2.Caption+'x2='+'i*'+hh;
                              lblSolution3.Caption:=lblSolution3.Caption+'x3='+'-i*'+hh;
                            end
                      end
                    else
                      begin
                        y3:=-sqrt(-ddd)/2/aa; // 
                        str(y3:5:7,hh);
                        if abs(y2)>1e-7
                          then
                            begin
                             lblSolution2.Caption:=lblSolution2.Caption+'x2='+h+'+i*'+hh;
                             lblSolution3.Caption:=lblSolution3.Caption+'x3='+h+'-i*'+hh;
                            end
                          else
                            begin
                              lblSolution2.Caption:=lblSolution2.Caption+'x2='+'i*'+hh;
                              lblSolution3.Caption:=lblSolution3.Caption+'x3='+'-i*'+hh;
                            end
                      end
                end
      end
    else
      begin
        //  
        aa:=b;
        bb:=c;
        cc:=d;
        if aa<>0
          then
            begin
              ddd:=bb*bb-4*aa*cc;
              if ddd>0
                then
                  begin
                    lblSolution.Caption:=lblSolution.Caption+'   2 ';
                    y1:=(-bb-sqrt(ddd))/2/aa;
                    y2:=(-bb+sqrt(ddd))/2/aa;
                    str(y1:5:7,h);
                    lblSolution2.Caption:=lblSolution2.Caption+'x2='+h;
                    str(y2:5:7,h);
                    lblSolution3.Caption:=lblSolution3.Caption+'x3='+h
                  end
                else
                  if ddd=0
                    then
                      begin
                        lblSolution.Caption:=lblSolution.Caption+'   2  ';
                        y1:=-bb/2/aa;
                        str(y1:5:7,h);
                        lblSolution2.Caption:=lblSolution2.Caption+'x2='+h;
                        lblSolution3.Caption:=lblSolution3.Caption+'x3='+h
                      end
                    else
                      begin
                        //  
                        lblSolution.Caption:=lblSolution.Caption+'   2  ';
                        y2:=-bb/2/aa; // 
                        y3:=sqrt(-ddd)/2/aa; // 
                        str(y2:5:7,h);
                        str(y3:5:7,hh);
                        if a>0
                          then
                            begin
                              if abs(y2)>1e-7
                                then
                                  begin
                                    lblSolution2.Caption:=lblSolution2.Caption+'x2='+h+'+i*'+hh;
                                    lblSolution3.Caption:=lblSolution3.Caption+'x3='+h+'-i*'+hh;
                                  end
                                else
                                  begin
                                    lblSolution2.Caption:=lblSolution2.Caption+'x2='+'i*'+hh;
                                    lblSolution3.Caption:=lblSolution3.Caption+'x3='+'-i*'+hh;
                                  end
                            end
                          else
                            begin
                              y3:=-sqrt(-ddd)/2/aa; // 
                              str(y3:5:7,hh);
                              if abs(y2)>1e-7
                                then
                                  begin
                                    lblSolution2.Caption:=lblSolution2.Caption+'x2='+h+'+i*'+hh;
                                    lblSolution3.Caption:=lblSolution3.Caption+'x3='+h+'-i*'+hh;
                                  end
                                else
                                  begin
                                    lblSolution2.Caption:=lblSolution2.Caption+'x2='+'i*'+hh;
                                    lblSolution3.Caption:=lblSolution3.Caption+'x3='+'-i*'+hh;
                                  end
                            end
                      end
              end
          else
            begin
              //linear eq
              if bb<>0
                then
                  begin
                    y1:=-cc/bb;
                    str(y1:5:7,hh);
                    lblSolution.Caption:=lblSolution.Caption+'  1 ';
                    lblSolution2.Caption:=lblSolution2.Caption+'x1='+hh;
                  end
                else
                  if cc<>0
                    then
                      begin
                        lblSolution.Caption:=lblSolution.Caption+'  ';
                      end
                    else
                      begin
                        lblSolution.Caption:=lblSolution.Caption+'  ';
                      end
            end
      end

end;

procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  editA.Text:='';
  editB.Text:='';
  editC.Text:='';
  editD.Text:='';
  lblSolution.Caption:=':';
  lblSolution2.Caption:='';
  lblSolution3.Caption:='';
  lblTest1.Caption:='f(x1)=';
  lblTest2.Caption:='f(x2)=';
  lblTest3.Caption:='f(x3)='
end;

procedure TfrmMain.mnuSolveClick(Sender: TObject);
begin
  btnSolve.Click
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  application.Terminate
end;

procedure TfrmMain.btnRandomClick(Sender: TObject);
  const maxI=20;
  var i:integer;
      h:string;
begin
  randomize;
  i:=random(2*maxI)-maxI;  str(i,h); EditA.Text:=h;
  i:=random(2*maxI)-maxI;  str(i,h); EditB.Text:=h;
  i:=random(2*maxI)-maxI;  str(i,h); EditC.Text:=h;
  i:=random(2*maxI)-maxI;  str(i,h); EditD.Text:=h;
  lblSolution.Caption:=':';
  lblSolution2.Caption:='';
  lblSolution3.Caption:='';
  lblTest1.Caption:='f(x1)=';
  lblTest2.Caption:='f(x2)=';
  lblTest3.Caption:='f(x3)=';
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  application.Terminate
end;

procedure TfrmMain.popmnusolveClick(Sender: TObject);
begin
  btnSolve.Click
end;

procedure TfrmMain.popmnuClearClick(Sender: TObject);
begin
  btnClear.Click
end;

procedure TfrmMain.popmnuExitClick(Sender: TObject);
begin
  btnExit.Click
end;

procedure TfrmMain.btnTestClick(Sender: TObject);
  var t:double;
      h:string;
begin
  t:=a*y*y*y+b*y*y+c*y+d;
  t:=abs(t);
  str(t:5:7,h);
  lblTest1.Caption:=lblTest1.Caption+h
end;

procedure TfrmMain.mnuRandomClick(Sender: TObject);
begin
  btnRandom.Click
end;

procedure TfrmMain.mnuClearClick(Sender: TObject);
begin
  btnClear.Click
end;

end.
